PHP大規模開発入門 第8回
======================

『PHPDocでコードの品質を保つ』のサンプルコードです。PHPと[Composer](https://getcomposer.org/)を導入することで、実際に動作させることが可能です。

PHPDocとComposerを使った簡単なPHPプロジェクトの例になっています。

## インストール

### Composer

Composerを導入していない場合は https://getcomposer.org/doc/00-intro.md に従ってComposerをインストールしてください。

`composer`コマンドが利用可能になったら、コマンドラインでこのディレクトリに移動して以下のコマンドを実行してください。

```
composer install
```

### PhpStorm

PhpStormは有償の製品です。 https://www.jetbrains.com/phpstorm/ よりダウンロードして30日間無料で試用可能です。

## PHPのリフレクションとDocComment

PHPのリフレクション機能(`ReflectionClass`)と[zonuexe/simple-annotations](https://packagist.org/packages/zonuexe/simple-annotations)ライブラリを使って簡易的にPHPDocを解析するサンプルです。

## デザインレシピに沿った開発

記事本文では記述と実装を簡便にするためにテストコードと実装を同じファイルに記述していますが、サンプルプロジェクトでは`src/functions.php`と`tests/TrapezoidTest.php`に分割しています。

Composerをインストールした環境では次のコマンドを実行することでテストを行うことができます。

```
php ./vendor/bin/phpunit
```

記事本文と同様に失敗するテストになっていますので、修正してみてください。

## PHPDocと型

PhpStormで`phpstorm-input.php`を開くと入力補完が機能することをチェックできます。


