<?php
namespace WebDB87\Sample\Model;

/**
 * これはファイル冒頭のDocCommentですが、不要なので削除してしまって構いません
 */

/**
 * サイトの投稿者を表現するクラス
 *
 * これはクラスのDocCommentです。
 *
 * @package WebDB87\Sample\Model
 * @author USAMI Kenta
 * @copyright 2015 USAMI Kenta
 * @license https://creativecommons.org/choose/zero/ CC0-1.0
 * @property-read int    $id
 * @property-read string $slug
 * @property-read string $name
 */
final class User
{
    /** @var int */
    private $id;

    /** @var string URLなどに利用する文字列 */
    private $slug;

    /** @var string */
    private $name;

    /**
     * @param int    $id
     * @param string $slug
     * @param string $name
     */
    public function __construct($id, $slug, $name)
    {
        $this->id = $id;
        $this->slug = $slug;
        $this->name = $name;
    }

    /**
     * privateなプロパティを読み出し専用で公開するイディオム
     */
    public function __get($name)
    {
        return $this->$name;
    }

    /**
     * privateなプロパティを読み出し専用で公開するイディオム
     */
    public function __isset($name)
    {
        return isset($this->$name);
    }

    /**
     * プロパティの書き込みを阻止するイディオム
     */
    public function __set($name, $value)
    {
        throw new \LogicException("未定義のプロパティに書き込もうとしています");
    }
}
