<?php

/**
 * クラスに属さない関数を定義するファイルです
 *
 * @package WebDB87\Sample
 * @author USAMI Kenta
 * @copyright 2015 USAMI Kenta
 * @license https://creativecommons.org/choose/zero/ CC0-1.0
 */

namespace WebDB87\Sample
{
    /**
     * 台形の面積を求める
     *
     * @param  int|float $height 高さ
     * @param  int|float $b1     上底
     * @param  int|float $b2     下底
     * @return float             台形の面積
     */
    function trapezoid($height, $b1, $b2) {
        return ($b1 + $b2) * $height / 2;
    }

    /**
     * @deprecated
     */
    function oldFunc()
    {
        echo "I'm obsolete!", PHP_EOL;
    }

    /**
     * @throws \Exception
     */
    function buggyFunc()
    {
        throw new \Exception('bug!');
    }

    /**
     * @return void
     */
    function voidFunc()
    {
        // なにも返さない
        return;
    }
}
